#!/bin/bash
#
# tcpaw			Starts TCP Tunneling
#
#
# chkconfig: 2345 12 88
# processname: tcpaw.pl
# pidfile: /var/run/tcpaw.pid
# description: TCP Proxy tunneling service

### BEGIN INIT INFO
# Provides: $tcpaw
### END INIT INFO

# Source function library.
. /etc/init.d/functions

[ -f /etc/tcpaw/tcpaw.pl ] || exit 0
#[ -f /tmp/office ] || exit 0

RETVAL=0

umask 077

start() {
	cd /etc/tcpaw
 	echo -n $"Starting POP3 redirection: "
	daemon tcppop3.sh
	RETVAL=$?
	echo
	echo -n $"Starting SMTP redirection: "
	daemon tcpsmtp.sh
	echo
	[ $RETVAL -eq 0 ] && touch /var/lock/subsys/tcpaw
	return $RETVAL
}	
stop() {
	echo -n $"Shutting down TCP redirection: "
	killall tcpaw.pl
	RETVAL=$?
	echo
	[ $RETVAL -eq 0 ] && rm -f /var/lock/subsys/tcpaw
	return $RETVAL
}
rhstatus() {
	status tcpaw
}
restart() {
	stop
	start
}	

case "$1" in
  start)
  	start
	;;
  stop)
  	stop
	;;
  status)
  	rhstatus
	;;
  restart|reload)
  	restart
	;;
  condrestart)
  	[ -f /var/lock/subsys/tcpaw ] && restart || :
	;;
  *)
	echo $"Usage: $0 {start|stop|status|restart|condrestart}"
	exit 1
esac

exit $?

