#!/usr/bin/perl
# TCP/Anywhere v1.5
# (C) 2001-2002 Andrew Wyatt, FEWT Software (http://www.fewt.com)
#TCP/AW may be copied only under the terms of either the Artistic License or the
#GNU General Public License, which may be found in the redistributable archive.

if ($ARGV[1] =~/-s/i) {
  $log=1;
}

$log=1 && print <<eof;

TCP/Anywhere v1.5a
(C) 2001-2003 Andrew Wyatt, FEWT Software (http://www.fewt.com)
If you like this program, please consider donating.

This software is provided as-is, it is a computer program, as
with all computer software it may also contain bugs. The author
takes no responsibility for any result of running this application.
If you do not agree press control-c now, and delete all copies of
this application.

TCP/AW may be copied only under the terms of either the Artistic License or the
GNU General Public License, which may be found in the redistributable archive.
eof

use POSIX;
use DynaLoader;
use IO::Socket;
use Socket;

$cwd=POSIX::getcwd();

unless (-e "$cwd/$ARGV[0]")
{
	die "\nPlease configure tcpaw first.\n(or cd into the tcpaw folder before starting)\n";
}
else
{
	if (-e "$cwd/$ARGV[0]")
	{
		open (CONFIG,"<$cwd/$ARGV[0]");
		@config=<CONFIG>;
		close (CONFIG);
	}
	foreach (@config)
	{
		#strip comments ..
		if ($_ =~/\#/gi)
		{
			($_,$junked) = split (/\#/,$_);
		}
		($key,$value) = split(/\=/,$_);
		$value =~s/\s//gi;
		chomp $value;
		$$key = $value;
	}
}
chomp $remote;
($address,$dstport)=split(/:/,$remote);
$listen = IO::Socket::INET->new(	 'LocalPort' => $port,
										'Listen' => $connections,
										'Proto'=> 'tcp',
										'Reuse'=> 1) || die "Can not start server";
chomp ($uname=`which uname`);
if (-e $uname) {
  chomp ($OS=`uname -o`);
  use POSIX qw(setsid); 										
  unless ($OS =~/Cygwin/i) {
    chdir '/';
    umask 0;
    open (STDIN,'/dev/null');
    open (STDERR,'>/dev/null');
    defined($pid=fork) || die "Can not fork..";
    exit if $pid;
    setsid;
  } else {
    print "Running, closing this window kills TCP/Anywhere.\n";
  }
} else {
  print "This system is not capable of running this application. Please execute this script on a unix platform, or using Cygwin if on Win32.\n";
  exit(0);
}


while (my $connect = $listen->accept())
{
  $peer=$connect->peerhost();
  if ($local eq 0) {
    unless ($peer =~/127.0.0.1/i) {
      close $connect;
      next;
    }
  }
  $connect->autoflush(1);
  if ($child=fork) {
    &process_child($connect,$proxyaddress,$proxyport,$address,$dstport,$child);
    exit;
  }
}

sub process_child {
  $connect=$_[0];
  $proxaddr=$_[1];
  $proxport=$_[2];
  $address=$_[3];
  $port=$_[4];
  $process=$_[5];
  $proxy_connect = IO::Socket::INET->new(PeerAddr=>$proxaddr,
                                PeerPort=>$proxport,
                                Proto=>'tcp') || die "Failed to create outbound socket!\n";
 
  $connect ->autoflush(1);
  $proxy_connect->autoflush(1);
  STDOUT->autoflush(1);

  print $proxy_connect "CONNECT $address:$port HTTP/1.0\r\n\r\n";
  sysread($proxy_connect,$garbage,2048);

  if ($mypid=fork) {
    $npid=fork;
    if ($npid == 0) {
      while (sysread($connect,$cbyte,2048)) {
        print $proxy_connect $cbyte;
        $proxy_connect->autoflush(1);
      }
    } else {
      while (sysread($proxy_connect,$rbyte,2048)) {
        print $connect $rbyte;
        $connect->autoflush(1);
      }
      close $connect;
      close $proxy_connect;
      kill 9,$npid;
    }
  }
  exit;
}
